package;

import flash.display3D.IndexBuffer3D;
import flixel.FlxG;
import flixel.FlxState;
import flixel.text.FlxText;
import flixel.ui.FlxButton;
import flixel.util.FlxColor;

/**
 * ...
 * @author Nicolas Korbel
 */
class EndState extends FlxState
{

	var uiTextGameOver:FlxText;
	var uiTextGameOverRounds:FlxText;
	var uiRestartButton:FlxButton;
	var uiBackToMenu:FlxButton;
	var rounds:Int;

	public function new(rounds:Int)
	{
		super();
		this.rounds = rounds;
	}

	override public function create():Void
	{
		super.create();
		bgColor = FlxColor.RED;
		loadGameOverScreen();

		#if flash
		FlxG.sound.playMusic(AssetPaths.FatherHustlerChilltime__wav, .5, true);
		#end
		#if (html5 || desktop)
		FlxG.sound.playMusic(AssetPaths.FatherHustlerChilltime__ogg, .5, true);
		#end
	}

	public function loadGameOverScreen()
	{
		uiTextGameOver = new FlxText(0, FlxG.height /2 -32, FlxG.width, "GAME OVER", 64);
		uiTextGameOver.font = AssetPaths.Joust__ttf;
		uiTextGameOver.alignment = FlxTextAlign.CENTER;
		add(uiTextGameOver);

		uiTextGameOverRounds = new FlxText(0, uiTextGameOver.y + 74, FlxG.width, "Wave #" + rounds + " killed you", 32);
		uiTextGameOverRounds.font = AssetPaths.Joust__ttf;
		uiTextGameOverRounds.alignment = FlxTextAlign.CENTER;
		add(uiTextGameOverRounds);

		uiRestartButton = new FlxButton(0, uiTextGameOverRounds.y + 42, "Restart", restartGame);
		uiRestartButton.x = FlxG.width / 2 - uiRestartButton.width / 2;
		add(uiRestartButton);
		
		uiBackToMenu = new FlxButton( 0, uiRestartButton.y + 42,"Back to Menu", backToMenu);
		uiBackToMenu.x = FlxG.width / 2 - uiBackToMenu.width / 2;
		add(uiBackToMenu);
		
	}

	function restartGame()
	{
		FlxG.switchState(new PlayState());
	}
	
	function backToMenu()
	{
		FlxG.switchState(new MenuState());
	}

}