package;

import flixel.FlxG;
import flixel.FlxSprite;
import flixel.FlxState;
import flixel.text.FlxText;
import flixel.ui.FlxButton;
import flixel.util.FlxColor;

/**
 * ...
 * @author Nicolas Korbel
 */
class MenuState extends FlxState
{

	var textTitle:FlxText;
	var textBy:FlxText;
	var buttonStart:FlxButton;
	var buttonHowTo:FlxButton;

	override public function create():Void
	{
		super.create();

		add(new FlxSprite(0, 0, AssetPaths.Title__png));

		if (FlxG.sound.music == null)
		{
			#if flash
			FlxG.sound.playMusic(AssetPaths.FatherHustlerChilltime__wav);
			#end

			#if (html5 || desktop)
			FlxG.sound.playMusic(AssetPaths.FatherHustlerChilltime__ogg);
			#end
		}

		textTitle = new FlxText(0, 50, FlxG.width, "Father Hustler and his holy room", 80);
		textTitle.font = AssetPaths.Joust__ttf;
		textTitle.color = FlxColor.GRAY;
		textTitle.alignment = FlxTextAlign.CENTER;
		textTitle.setBorderStyle(FlxTextBorderStyle.SHADOW, FlxColor.RED, 2, 1);
		add(textTitle);

		buttonStart = new FlxButton(FlxG.width / 2 -50, textTitle.y + 20 + textTitle.height, "START GAME", startGame);
		buttonStart.width = 200;
		add(buttonStart);

		buttonHowTo = new FlxButton(FlxG.width / 2 -50, buttonStart.y + 20 + buttonStart.height, "HOW TO PLAY", howToPlay);
		buttonHowTo.width = 200;
		add(buttonHowTo);

		textBy = new FlxText(0, FlxG.height - 32, FlxG.width, "By Nicolas Korbel Twitter: @gamedevbynight", 32);
		textBy.font = AssetPaths.Joust__ttf;
		textBy.color = FlxColor.GRAY;
		textBy.alignment = FlxTextAlign.CENTER;
		textBy.setBorderStyle(FlxTextBorderStyle.SHADOW, FlxColor.RED, 2, 1);
		add( textBy );
	}

	function startGame()
	{
		FlxG.switchState(new PlayState());
	}

	function howToPlay()
	{
		openSubState(new HowTo());
	}

}