package entities;

import flixel.util.FlxColor;
import flixel.util.FlxTimer;
import helper.Entity;
import helper.HealthBar;

/**
 * ...
 * @author Nicolas Korbel
 */
class Enemy extends Entity
{
	
	public var maxHealth:Int;
	var damage:Int = 1;
	var damageTime:Float = 3;
	var damageTimer:FlxTimer;
	public var attackTime:Float = 2;
	
	
	public function new(?X:Float=0, ?Y:Float=0) 
	{
		super(X, Y);	
		healthBarColor = 0xFF9aeb00;
		
		damageTimer = new FlxTimer();
		damageTimer.finished = true;		
	}
	
	public function doDamage()
	{
		if (damageTimer.finished)
		{
			damageTimer.start(damageTime, hitIt);
		}
	}
	
	public function attack()
	{
		if(alive) state.player.hurt(damage);
	}
	
	function hitIt(timer:FlxTimer)
	{
		if(alive)state.holyRoom.hurt(damage);
	}
	
	override public function kill():Void 
	{
		super.kill();
		state.livingenemyCount --;
	}
	
	public function startAction()
	{
		
	}
	
	override public function revive():Void 
	{
		super.revive();
		health = maxHealth;
		healthBar.revive();
		
	}

	
}