package entities;

import flixel.FlxG;
import flixel.FlxSprite;
import flixel.system.FlxAssets.FlxGraphicAsset;
import flixel.util.FlxColor;
import flixel.util.FlxTimer;

/**
 * ...
 * @author Nicolas Korbel
 */
class EnemyZone extends FlxSprite
{

	var enemy:Enemy;

	var state:PlayState;
	var attackTimer:FlxTimer;
	var attackStarted:Bool = false;
	public function new( size:Int, enemy:Enemy)
	{
		super();

		state = cast FlxG.state;
		makeGraphic(size, size, FlxColor.TRANSPARENT);

		attackTimer = new FlxTimer();
		attackTimer.finished = true;

		this.enemy = enemy;
	}

	override public function update(elapsed:Float):Void
	{
		super.update(elapsed);

		updatePosition();
		
	}

	function updatePosition()
	{
		x = enemy.x - enemy.width / 2;
		y = enemy.y - enemy.height / 2;
	}

	public function attack()
	{
		if (attackReady())
		{
			enemy.attack();
			attackTimer.finished = false;
		}
	}

	public function attackReady():Bool
	{
		if (attackTimer.finished)
		{
			return true;
		}

		else if (attackTimer.active)
		{
			return false;
		}
		else
		{
			attackTimer.start(enemy.attackTime);
			return false;
		}

	}
}