package entities;

import flixel.FlxG;
import flixel.FlxSprite;
import flixel.system.FlxAssets.FlxGraphicAsset;
import flixel.system.FlxSound;

/**
 * ...
 * @author Nicolas Korbel
 */
class HolyRoom extends FlxSprite
{

	var damageSound:FlxSound;

	public function new(?X:Float=0, ?Y:Float=0)
	{
		super(X, Y);

		health = 8;

		loadGraphic(AssetPaths.HolyRoom__png, true, 128, 128);
		animation.add("8", [0], 1, false);
		animation.add("7", [1], 1, false);
		animation.add("6", [2], 1, false);
		animation.add("5", [3], 1, false);
		animation.add("4", [4], 1, false);
		animation.add("3", [5], 1, false);
		animation.add("2", [6], 1, false);
		animation.add("1", [7], 1, false);
		animation.play("8");

		set_visible(false);

		loadSounds();

	}

	function loadSounds()
	{
		#if flash
		damageSound = FlxG.sound.load(AssetPaths.holyRoomDamage__wav, .8);
		#end

		#if (html5 || desktop)
		damageSound = FlxG.sound.load(AssetPaths.holyRoomDamage__ogg, .8);
		#end
	}

	override public function hurt(Damage:Float):Void
	{
		super.hurt(Damage);
		if (alive)
		{
			FlxG.camera.shake(0.2, 0.1,null, true);
			damageSound.play(true);
		}
	}

	override public function update(elapsed:Float):Void
	{
		super.update(elapsed);

		var animationText:String = "" + health;
		animation.play(animationText);
	}

	override public function revive():Void
	{
		super.revive();
		health = 8;
	}

	public function setRoom(x:Float,y:Float)
	{
		this.x = x;
		this.y = y;
		set_visible(true);
		health = 8;
	}

}