package entities;

import flixel.FlxG;
import flixel.FlxSprite;
import flixel.system.FlxAssets.FlxGraphicAsset;
import flixel.system.FlxSound;

/**
 * ...
 * @author Nicolas Korbel
 */
class HolyWater extends Bullet
{

	static var SPEED:Float = 180;
	
	var sound:FlxSound;
	
	public function new(?X:Float=0, ?Y:Float=0) 
	{
		super(X, Y);
		loadGraphic(AssetPaths.HolyWater__png, true, 8, 8);
		animation.add("idle", [0], 1, false);
		animation.add("explode", [1, 2, 3, 4], 8, false);
		animation.play("idle");	
		
		animation.finishCallback = finishAnimation;
		
		sound = FlxG.sound.load(AssetPaths.explode__wav,.5);
		
	}
	
	override public function kill():Void 
	{
		animation.play("explode");
		sound.play(true);
		velocity.x *= .3;
		velocity.y *= .3;
		angularVelocity = 0;
	}
	
	function finishAnimation(name:String)
	{
		if (name == "explode")
		{
			super.kill();
		}
	}
	
	override public function revive():Void 
	{
		super.revive();
		animation.play("idle");
		velocity.set(0, 0);
	}
	
	override public function shoot(damage:Int) 
	{
		angularVelocity = 500;
		this.damage = damage;
	}
	
}