package entities;

import flixel.FlxG;
import flixel.FlxSprite;
import flixel.effects.particles.FlxEmitter;
import flixel.system.FlxAssets.FlxGraphicAsset;
import flixel.util.FlxColor;

/**
 * ...
 * @author Nicolas Korbel
 */
class PoisonCurtain extends FlxSprite
{
	
	public var emitter:FlxEmitter;
	
	public function new() 
	{
		super(0, 0);
		
		makeGraphic(FlxG.width, FlxG.height, FlxColor.PURPLE);
		set_alpha(.3);
		set_visible(false);
		
		emitter = new FlxEmitter(0, 0, 200);
		emitter.setSize(width, height);
		
		emitter.makeParticles(4, 4, FlxColor.GREEN, 200);
		//emitter.angularVelocity.set(1, 10, 25, 30);
		emitter.velocity.set(0, 5, 0, 10, 0, 10, 0, 20);
		emitter.lifespan.set(1, 2);			
	}
	
	
	public function startEvilTime()
	{
		set_visible(true);
		emitter.set_visible(true);
		emitter.start(false, 0.1, 0);
	}
	
	public function stopEvilTime()
	{
		emitter.set_visible(false);
		set_visible(false);
	}
	
}