package entities;

import flixel.FlxG;
import flixel.FlxSprite;
import flixel.system.FlxAssets.FlxGraphicAsset;
import flixel.system.FlxSound;
import flixel.text.FlxText;
import flixel.util.FlxTimer;
import player.Player;

/**
 * ...
 * @author Nicolas Korbel
 */
class PowerUp extends FlxSprite
{

	var sound:FlxSound;
	var state:PlayState;
	var text:FlxText;
	var timer:FlxTimer;
	var message:String;

	public function new(?X:Float=0, ?Y:Float=0)
	{
		super(X, Y);
		
		state = cast FlxG.state;
		
		text = state.uiPowerUpText;		
		timer = state.uiPowerUpTimer;
		
		#if flash
		sound = FlxG.sound.load(AssetPaths.Powerup__wav, 1);
		#end

		#if (html5 || desktop )
		sound = FlxG.sound.load(AssetPaths.Powerup__ogg, 1);
		#end
	}

	public function doEffect(player:Player)
	{
		sound.play();
		showText();
		kill();

	}
	
	function showText()
	{
		text.text = message;
		text.setPosition( state.player.x, state.player.y);
		text.velocity.set(0, -100);
		text.visible = true;
		timer.start(1, removeText);
	}
	
	function removeText(timer:FlxTimer)
	{
		text.visible = false;
		text.velocity.set(0, 0);
	}

}