package helper;

import flixel.FlxG;
import flixel.FlxSprite;
import flixel.system.FlxAssets.FlxGraphicAsset;
import flixel.util.FlxColor;

/**
 * ...
 * @author Nicolas Korbel
 */
class Entity extends FlxSprite
{
	
	public var healthBar:HealthBar;
	public var healthBarColor:FlxColor = FlxColor.RED;
	var state:PlayState;
	
	public function new(?X:Float=0, ?Y:Float=0) 
	{
		super(X, Y);
		state = cast FlxG.state;
		
	}
	
	public function setHealthBar( bar:HealthBar)
	{
		healthBar = bar;
	}
	
	override public function revive():Void 
	{
		super.revive();
		healthBar.revive();
	}
	
	override public function update(elapsed:Float):Void 
	{
		if (healthBar == null)
		{
			healthBar = new HealthBar(this, healthBarColor);
			state.add(healthBar);
		}
		
		super.update(elapsed);
	}
	
	override public function kill():Void 
	{
		super.kill();
		healthBar.kill();
	}
	
}