package helper;
import entities.HolyRoomHealthPowerUp;
import entities.HolyRoomPowerUp;
import entities.HolyWaterCountPowerUp;
import entities.HolyWaterSpeedPowerUp;
import entities.PowerUp;
import entities.WaterPowerUp;
import flixel.FlxG;

/**
 * ...
 * @author Nicolas Korbel
 */
class PowerUpManager
{

	public static var damagePowerUp:Int = 1;
	public static var speedPowerUp:Int = 2;
	public static var countPowerUp:Int = 3;
	public static var healthPowerUp:Int = 4;
	public static var roomPowerUp:Int = 5;

	var state:PlayState;

	public function new(state:PlayState)
	{
		this.state = state;
	}

	public function getRandomPowerUp():PowerUp
	{
		var id:Int = 1;
		
		var random:Int = FlxG.random.int(0, 100);
		
		if (random >= 0 &&  random < 25) id = damagePowerUp; // 25% Chance
		else if ( random >= 25 && random < 45 ) id = speedPowerUp; //20% Chance
		else if ( random >= 45 && random < 75 ) id = countPowerUp; // 30% Chance
		else if ( random >= 75 && random < 95 ) id = healthPowerUp; // 20% Chance
		else if ( random >= 95) id = roomPowerUp; // 5% Chance		

		return getPowerUp(id);

	}

	public function getPowerUp(ID:Int):PowerUp
	{
		var powerUp:PowerUp = null;
		switch (ID)
		{
			case 1:
				powerUp = state.powerUPs.recycle(WaterPowerUp, newDamageUp, true, true);
			case 2:
				powerUp = state.powerUPs.recycle(HolyWaterSpeedPowerUp, newSpeedUp, true, true);
			case 3:
				powerUp = state.powerUPs.recycle(HolyWaterCountPowerUp, newCountUp, true, true);
			case 4:
				powerUp = state.powerUPs.recycle(HolyRoomHealthPowerUp, newHealthUp, true, true);
			case 5:
				powerUp = state.powerUPs.recycle(HolyRoomPowerUp, newRoomUp, true, true);
			default:
				powerUp = state.powerUPs.recycle(HolyWaterCountPowerUp, newCountUp, true, true);
		}

		return powerUp;
	}

	function newDamageUp():PowerUp
	{
		var powerUp:PowerUp = new WaterPowerUp(0, 0);
		state.powerUPs.add(powerUp);
		return powerUp;
	}

	function newSpeedUp():PowerUp
	{
		var powerUp:PowerUp = new HolyWaterSpeedPowerUp(0, 0);
		state.powerUPs.add(powerUp);
		return powerUp;
	}

	function newHealthUp():PowerUp
	{
		var powerUp:PowerUp = new HolyRoomHealthPowerUp(0, 0);
		state.powerUPs.add(powerUp);
		return powerUp;
	}

	function newRoomUp():PowerUp
	{
		var powerUp:PowerUp = new HolyRoomPowerUp(0, 0);
		state.powerUPs.add(powerUp);
		return powerUp;
	}

	function newCountUp():PowerUp
	{
		var powerUp:PowerUp = new HolyWaterCountPowerUp(0, 0);
		state.powerUPs.add(powerUp);
		return powerUp;
	}

}