package helper;
import flixel.FlxG;
import flixel.util.FlxStringUtil;
import openfl.Assets;

/**
 * ...
 * @author Nicolas Korbel
 */
class RoundManager
{

	public var enemyArray:Array<Int>;

	var state:PlayState;
	public function new(state:PlayState)
	{
		this.state = state;

		enemyArray = new Array<Int>();
	}

	public function prepareNextRound(round:Int)
	{

		enemyArray = new Array<Int>();
		var waveSettings:String;
		
		waveSettings = Assets.getText("assets/data/" + round + ".txt");
		enemyArray = FlxStringUtil.toIntArray( waveSettings);
		if (enemyArray == null)
		{
			fillRandom();
		}

		for (i in 0...5)
		{
			switch (i) 
			{
				case 0: // enemyCount
					state.enemyCount = enemyArray.shift();
				case 1: //
					state.enemyMultiply = enemyArray.shift();
				case 2:
					state.specialEvent(enemyArray.shift());
				case 3:					
					state.nextRoundTime = enemyArray.shift();
				case 4:	
					var powerUP:Int = enemyArray.shift();
					state.addPowerUp(powerUP);
			}
			
		
		}		
	}
	
	function fillRandom()
	{
		
		enemyArray = new Array<Int>();
		// GegnerAnzahl
		var count:Int = state.enemyCount + 1;
		enemyArray.push(count);
		
		// Gegner Multyply
		enemyArray.push(FlxG.random.int(1, 4));
		
		// Event
		enemyArray.push(FlxG.random.int(0, 1));
		
		// Zeit bis zur nächsten Runde
		enemyArray.push(10); 
		
		// PowerUp
		enemyArray.push(0); // random
		
		for (i in 0...count)
		{
			enemyArray.push(FlxG.random.int(1, 4));
		}
		
		
		
		
	}


}