package helper;

import flixel.FlxG;
import flixel.FlxSprite;
import flixel.system.FlxAssets.FlxGraphicAsset;
import flixel.system.FlxSound;
import flixel.util.FlxColor;
import flixel.util.FlxTimer;

/**
 * ...
 * @author Nicolas Korbel
 */
class Whistle extends FlxSprite
{
	
	public var whistled:Bool;

	var whistleTime:FlxTimer;
	
	public function new(?X:Float=0, ?Y:Float=0, ?SimpleGraphic:FlxGraphicAsset) 
	{
		super(X, Y);
		loadGraphic(AssetPaths.Whistle__png, true, 128, 128);
		
		set_alpha(.2);
		
		animation.add("idle", [0], 1);
		animation.add("whistle", [1, 2, 3, 4], 16, true);
		
		animation.play("idle");
		
		whistleTime = new FlxTimer();
		whistled = false;
		
	}
	
	public function blowMyWhistle()
	{
		whistled = true;
		animation.play("whistle");
		whistleTime.start(.2, whistleFinished);
	}
	
	function whistleFinished(timer:FlxTimer)
	{
		whistled = false;
		animation.play("idle");
	}
	
}