package ui;
import flixel.FlxG;
import flixel.FlxSprite;
import flixel.group.FlxGroup.FlxTypedGroup;
import flixel.text.FlxText;
import flixel.util.FlxColor;

/**
 * ...
 * @author Nicolas Korbel
 */
class HowToPlayPage2
{
	public var uiGroup:FlxTypedGroup<FlxSprite>;

	public var text:FlxText;
	public var callText:FlxText;
	public var placeText:FlxText;
	public var throwText:FlxText;
	public var moveText:FlxText;
	public var gamedescription:FlxText;
	var sprite:FlxSprite;

	public function new(x:Float, y:Float)
	{
		uiGroup = new FlxTypedGroup<FlxSprite>();

		sprite = new FlxSprite(0, 0);
		sprite.makeGraphic(FlxG.width, FlxG.height, FlxColor.GRAY);
		sprite.alpha = .6;
		uiGroup.add(sprite);

		gamedescription = new FlxText(x, y -40, FlxG.width, "Gather your 'sheeps' in your holy room or they'll die", 32);
		gamedescription.font = AssetPaths.Joust__ttf;
		gamedescription.alignment = FlxTextAlign.CENTER;
		uiGroup.add(gamedescription);

		text = new FlxText(x, y, FlxG.width, "Press 'SPACE' to (re)place your holy room", 32);
		text.font = AssetPaths.Joust__ttf;
		text.alignment = FlxTextAlign.CENTER;
		uiGroup.add(text);

		callText = new FlxText(x, text.y + 40, FlxG.width, "Press 'E' to call your sheeps", 32);
		callText.font = AssetPaths.Joust__ttf;
		callText.alignment = FlxTextAlign.CENTER;
		uiGroup.add(callText);

		placeText = new FlxText(x, callText.y + 40, FlxG.width, "Press 'Q' to place your sheeps", 32);
		placeText.font = AssetPaths.Joust__ttf;
		placeText.alignment = FlxTextAlign.CENTER;
		uiGroup.add(placeText);

		throwText = new FlxText(x, placeText.y +40, FlxG.width, "Press 'LEFT-MOUSE' to throw holy water", 32);
		throwText.font = AssetPaths.Joust__ttf;
		throwText.alignment = FlxTextAlign.CENTER;
		uiGroup.add(throwText);		
		
		moveText = new FlxText(x, throwText.y +40, FlxG.width, "Move around with 'WASD' or 'ARROWS'", 32);
		moveText.font = AssetPaths.Joust__ttf;
		moveText.alignment = FlxTextAlign.CENTER;
		uiGroup.add(moveText);
		
		disable();

	}

	public function activate()
	{
		text.visible = true;
		callText.visible = true;
		placeText.visible = true;
		throwText.visible = true;
		sprite.visible = true;
		gamedescription.visible = true;
		moveText.visible = true;
	}

	public function disable()
	{
		text.visible = false;
		callText.visible = false;
		placeText.visible = false;
		throwText.visible = false;
		sprite.visible = false;
		gamedescription.visible = false;
		moveText.visible = false;

	}

}