package ui;
import flixel.FlxSprite;
import flixel.group.FlxGroup.FlxTypedGroup;
import flixel.text.FlxText;
import flixel.util.FlxColor;
import player.Player;

/**
 * ...
 * @author Nicolas Korbel
 */
class UIHolyRoom
{

	public var uiGroup:FlxTypedGroup<FlxSprite>;
	var countText:FlxText;
	var player:Player;
	var x:Float;
	var y:Float;
	
	
	public function new(X:Float=0, Y:Float=0, player:Player) 
	{
		x = X;
		y = Y;
		
		this.player = player;
		uiGroup = new FlxTypedGroup<FlxSprite>();
		
		var sprite:FlxSprite = new FlxSprite(x, y);
		sprite.makeGraphic(32, 32, FlxColor.GRAY);
		sprite.alpha = .8;
		
		uiGroup.add(sprite);
		
		uiGroup.add(new FlxSprite(x, y, AssetPaths.HolyRoomIcon__png));
		
		countText = new FlxText(x+8, y, 32, getCount(), 32);
		countText.font = AssetPaths.Joust__ttf;
		countText.color = FlxColor.BLACK;
		uiGroup.add(countText);	
		
	}
	
	function getCount():String
	{
		return "" + player.holyRoomCount;
	}
	
	public function update(elapsed:Float)
	{
		countText.text = getCount();
	}
	
}