package ui;
import entities.RandomHuman;
import flixel.FlxSprite;
import flixel.group.FlxGroup.FlxTypedGroup;
import flixel.text.FlxText;
import flixel.util.FlxColor;

/**
 * ...
 * @author Nicolas Korbel
 */
class UIHumanCount
{
	public var uiGroup:FlxTypedGroup<FlxSprite>;
	var countText:FlxText;
	var x:Float;
	var y:Float;
	var humans:FlxTypedGroup<RandomHuman>;

	public function new(X:Float=0, Y:Float=0, humans:FlxTypedGroup<RandomHuman>)
	{
		x = X;
		y = Y;

		this.humans = humans;
		uiGroup = new FlxTypedGroup<FlxSprite>();

		var sprite:FlxSprite = new FlxSprite(x, y);
		sprite.makeGraphic(32, 32, FlxColor.GRAY);
		sprite.alpha = .8;

		uiGroup.add(sprite);

		uiGroup.add(new FlxSprite(x, y, AssetPaths.HumanIcon__png));

		countText = new FlxText(x+4, y, 32, getCount(),32);
		countText.font = AssetPaths.Joust__ttf;
		countText.color = FlxColor.BLACK;
		uiGroup.add(countText);

	}

	function getCount():String
	{
		return "" + humans.countLiving();
		//return "" + 10;
	}

	public function update(elapsed:Float)
	{
		countText.text = getCount();

	}

}